Bug 487061

Summary: Japanese fonts changed to less readable after update
Product: [Fedora] Fedora Reporter: Wojciech Pisarski <mcmonster>
Component: vlgothic-fontsAssignee: Akira TAGOH <tagoh>
Status: ASSIGNED --- QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: low Docs Contact:
Priority: low    
Version: rawhideCC: fonts-bugs, i18n-bugs, mcmonster, petersen, ryo-dairiki, sacredfox, tagoh, tfujiwar
Target Milestone: ---Keywords: FutureFeature
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Attachments:
Description Flags
Screenshot of gnome-terminal w/ old VLGothic* packages.
none
Screenshot of gnome-terminal w/ new vlgothic* packages. none

Description Wojciech Pisarski 2009-02-23 17:16:42 EST
User-Agent:       Mozilla/5.0 (X11; U; Linux x86_64; pl-PL; rv:1.9.0.6) Gecko/2009020410 Fedora/3.0.6-1.fc10 Firefox/3.0.6

I'm using irssi on gnome-terminal (Monospace font), after update Japanese fonts changed, they're now much smaller (compared to latin), harder to read (some ideograms are completely unreadable). It is very annoying, because I use Japanese and sit on Japanese channel a lot. The change occured only in terminal, in gEdit and other applications old fonts are still used for typing (SCIM + Anthy) and displaying.

The change didn't affect everyone, some Fedora 10 still got old, simple and readable fonts.

Reproducible: Always

Steps to Reproduce:
Just try displaying any Japanese text.



This is the update, that probably changed fonts:

Feb 14 02:31:53 Installed: vlgothic-fonts-common-20090204-2.fc10.noarch
Feb 14 02:32:39 Installed: vlgothic-fonts-20090204-2.fc10.noarch
Feb 14 02:32:42 Installed: vlgothic-p-fonts-20090204-2.fc10.noarch
Feb 14 02:33:28 Erased: VLGothic-fonts
Feb 14 02:33:30 Erased: VLGothic-fonts-proportional

]# LANG=C yum list vlgothic\*
Loaded plugins: refresh-packagekit
Installed Packages
vlgothic-fonts.noarch                        20090204-2.fc10           installed
vlgothic-fonts-common.noarch                 20090204-2.fc10           installed
Available Packages
VLGothic-fonts.noarch                        20081029-1.fc10           updates  
VLGothic-fonts-proportional.noarch           20081029-1.fc10           updates  
vlgothic-p-fonts.noarch                      20090204-2.fc10           updates
Comment 1 Akihiro Nomura 2009-03-28 03:16:42 EDT
Created attachment 337093 [details]
Screenshot of gnome-terminal w/ old VLGothic* packages.

I faced the same problem and I'm still using old VLGothic-* packages.
On this update, font size of terminal get smaller and width of ideograms (like ● and □) become wrong.
In older VLGothic-*, their cosmetic width is hankaku (1/2 of height, like English alphabet) and its actual width (used to calculate the position of next character) is also hankaku.
But in new vlgothic-*, their cosmetic width become zenkaku (same as height, like CJK character) but its actual width is treated as hankaku.
Please compare the screenshots, I put ideograms without space in left side, and with 1 space between each characters in right side.
Comment 2 Akihiro Nomura 2009-03-28 03:17:41 EDT
Created attachment 337094 [details]
 Screenshot of gnome-terminal w/ new vlgothic* packages.
Comment 3 Akihiro Nomura 2009-04-28 23:26:31 EDT
I tried a patch proposed in #485566 and it solves my problem.
I think this is the same behaviour to older VLGothic-* packages as far as I can see.
Comment 4 Akihiro Nomura 2009-06-18 07:01:37 EDT
In fedora 11, CJK ambiguous width ideograms are rendered and treated as zenkaku(full-width) in gnome-terminal.
It renders these ideograms without error that I mentioned in Comment #1.
But rendering them as Zenkaku(full-width) makes vim confused.
In F11's default setting, default value of ambiwidth option in vim is always single, vim assumes these ideograms are rendered as Hankaku(half-width).
If this setting is wrong, cursor position in vim gets wrong and hard to edit the files including these ideograms.
This behaviour makes all Japanese F11 & vim user confusing.

There are 2 ways to solve this problem:

A: Put a vim script that detects accurate ambiwidth option in /etc/vimrc (change vim)
B: Make default width of these ideograms to Hankaku (change fontconfig/vlgothic)

I don't know whether this buggy behaviour is vim's bug or fontconfig/vlgothic's bug, but I think solution B is better for users, because changing /etc/vimrc may bring another additional error to the people who don't use CJK characters and these buggy behaviour is brought by fontconfig/vlgothic changes.

If I should open another bug for this problem, please let me know so.
Comment 5 fujiwara 2009-07-15 00:02:31 EDT
It seems the vte algorithm is fixed recently.
http://svn.gnome.org/viewvc/vte/trunk/src/iso2022.c?r1=2259&r2=2340

I would think to set ambiwidth=double in your .vimrc
Or another enhancement is to set ambiwidth for CJK locales only by default.
Comment 6 Akira TAGOH 2009-07-15 00:35:59 EDT
Well, I still have no idea to figure out what's the right direction to fix this. the recommendation how to deal with the ambiguous width characters is described in http://www.unicode.org/reports/tr11/tr11-16.html#Recommendations, but it's only the case for legacy character encodings.

That may means we have to deal with them as narrow characters in Unicode. but modifying the vector data to fit within is misleading IMHO because it's still possible to use in other Japanese encodings and those are basically handling them as wide characters. which may also means any fixes may be unlikely happenning in upstream.  Aside from that, given that modifying a font in Fedora, that may introduces another bugs/regressions because fontforge sometimes do the weird thing and easily breaks unfortunately. that may confuses people and upstream. I'm afraid I don't want to make such changes.

Ideally TrueType/OpenType should has any properties to do that and fontconfig or freetype changes it as needed. dunno.
Comment 7 Bug Zapper 2009-11-18 07:46:33 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 8 Akira TAGOH 2009-12-08 02:57:15 EST
There may be no way of fixing this unless applications deals with it. I'm still at the same position to comment #6, still thinking fixing this at the vlgothic font isn't a good idea. it didn't just appear before because we didn't use this font for Latin for another reason. I'll keep it open until we find the right solution.
Comment 9 Bug Zapper 2010-03-15 08:26:05 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 13 development cycle.
Changing version to '13'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 10 Jens Petersen 2010-07-08 02:05:57 EDT
Is it any better in F13?

(In reply to comment #5)
> It seems the vte algorithm is fixed recently.
> http://svn.gnome.org/viewvc/vte/trunk/src/iso2022.c?r1=2259&r2=2340
> 
> I would think to set ambiwidth=double in your .vimrc
> Or another enhancement is to set ambiwidth for CJK locales only by default.
Comment 11 Akira TAGOH 2011-01-06 04:44:40 EST
still happens in even rawhide. I'm planning to "blacklist" them in fontconfig config file with upcoming release of fontconfig to avoid picking them up.
Comment 12 Fedora End Of Life 2013-04-03 16:17:31 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 13 Fedora End Of Life 2015-01-09 16:38:35 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.